#ifndef SIMULATION_H
#define SIMULATION_H

#include "cell.h"
#include <QVector>

class Simulation {
protected:
    void _checkAndSetBorder(int x, int y, QVector<QVector<Cell> > & cells);
    void _updateBorders(QVector<QVector<Cell> > & cells);
    void _getAllNeighbors(QVector<QVector<Cell> > &cells, int x, int y, QVector<CellLocation> &neighbors);
    void _cellsOnBorder(QVector<QVector<Cell> > &cells, QVector<CellLocation> &onBorder);
    void _getMatchingNeighbors(QVector<QVector<Cell> > & cells, int x, int y, bool empty, bool recristalized, QVector<CellLocation> &matching);

public:
    virtual void step(QVector<QVector<Cell> > & src, QVector<QVector<Cell> > & dest, bool boundaryPeriodic, QVector<struct CellLocation> & emptyCells) = 0;
};

#endif // SIMULATION_H
