#include "wndinclusions.h"
#include "ui_wndinclusions.h"
#include "space.h"

WndInclusions::WndInclusions(QWidget *parent) : QDialog(parent), _ui(new Ui::WndInclusions) {
    _ui->setupUi(this);

    connect(_ui->pbAdd, SIGNAL(clicked()), this, SLOT(_add()));
    connect(_ui->pbRemove, SIGNAL(clicked()), this, SLOT(_remove()));
}

WndInclusions::~WndInclusions() {
    delete _ui;
}

QVector<Inclusion> WndInclusions::getInclusionList() {
    return _inclusions;
}

void WndInclusions::changeEvent(QEvent *e) {
    QDialog::changeEvent(e);
    switch (e->type()) {
    case QEvent::LanguageChange:
        _ui->retranslateUi(this);
        break;
    default:
        break;
    }
}

void WndInclusions::_add() {
    struct Inclusion inc;
    QListWidgetItem * item;

    inc.dimension = _ui->sbDimension->value();
    inc.isRounded = (_ui->cbType->currentIndex() == 1);

    item = new QListWidgetItem(_ui->lwInclusions);
    item->setText(QString("Type: %1, dimension: %2").arg(inc.isRounded ? "Circular" : "Square").arg(inc.dimension));
    _inclusions.append(inc);
}

void WndInclusions::_remove() {

}
